<template>
  <app-user-page :breadcrumbs="breadcrumbs">
    <CCard>
      <CCardBody>
        <result-search-form
          :default-condition="condition"
          :loading="loading"
          @submit="onSearch"
        />

        <result-bid-success :data="bids" />

        <div class="main-control">
          <app-sort
            :value="sortId"
            :list="SORT_LIST"
            :name="'ソート'"
            :placeholder="'選んでください'"
            :disabled="loading"
            @sort-change="onSort"
          />
          <app-pagination
            :total="total"
            :page-size="limit"
            :current-page="page"
            :item-name="'商品'"
            :disabled="loading"
            @page-change="onPageChange"
            @page-size-change="onPageSizeChange"
          />
        </div>

        <result-table
          :products="products"
          :loading="loading"
          @detail="onShowDetail"
        />

        <div class="main-control">
          <app-sort
            :value="sortId"
            :list="SORT_LIST"
            :name="'ソート'"
            :placeholder="'選んでください'"
            :disabled="loading"
            @sort-change="onSort"
          />
          <app-pagination
            :total="total"
            :page-size="limit"
            :current-page="page"
            :item-name="'商品'"
            :disabled="loading"
            @page-change="onPageChange"
            @page-size-change="onPageSizeChange"
          />
        </div>
      </CCardBody>

      <CCardFooter>
        <div class="card-footer-actions">
          <CButton
            color="secondary"
            to="/boxes"
          >
            <font-awesome-icon :icon="['fas', 'arrow-left']" />
            箱一覧へ
          </CButton>
          <a
            target="_blank"
            rel="noopener noreferrer"
            href="#"
            class="btn btn-secondary"
          >
            <font-awesome-icon :icon="['fas', 'download']" />
            PDFダウンロード
          </a>
        </div>
      </CCardFooter>
    </CCard>

    <result-detail-modal
      :id="selectedId"
      ref="resultDetailModal"
    />
  </app-user-page>
</template>

<style lang="scss" scoped>
  .result-page {
    /deep/ {
    }
  }
</style>

<script>
import ResultSearchForm from '~/components/organisms/results/ResultSearchForm'
import ResultTable from '~/components/organisms/results/ResultTable'
import ResultBidSuccess from '~/components/organisms/results/ResultBidSuccess'
import AppPagination from '~/components/atoms/AppPagination'
import AppSort from '~/components/atoms/AppSort'
import ResultDetailModal from '~/components/organisms/results/ResultDetailModal'

import AsyncLoading from '~/mixins/do-async-loading'
import ConditionHandler from '~/mixins/condition'
import SearchFormHandler from '~/mixins/search-form'
import Paginator from '~/mixins/paginator'
import SortHandler from '~/mixins/sort'

const SORT_LIST = [
  {
    id: 1,
    label: 'ID ASC',
    sort: 'id',
    sortType: 1
  },
  {
    id: 2,
    label: 'ID DESC',
    sort: 'id',
    sortType: 0
  }
]

export default {
  layout: 'user',

  components: {
    ResultSearchForm,
    ResultTable,
    ResultBidSuccess,
    AppPagination,
    AppSort,
    ResultDetailModal
  },

  mixins: [
    AsyncLoading,
    ConditionHandler,
    SearchFormHandler,
    Paginator,
    SortHandler
  ],

  data () {
    return {
      resourceTypeName: 'result',
      total: 0,
      bids: [],
      products: [],
      selectedId: null,
      SORT_LIST,
      sortId: null
    }
  },

  computed: {
    /**
     * Generate breadcrumbs
     *
     * @return {array} List breadcrumbs
     */
    breadcrumbs () {
      return [
        {
          text: 'ホーム',
          to: '/'
        },
        {
          text: '結果一覧'
        }
      ]
    },

    /**
     * Get query
     */
    query () {
      return Object.assign({}, this.paginationQuery, this.conditionQuery, {
        sort: this.sort,
        sortType: this.sortType
      })
    }
  },

  mounted () {
    this.refresh()
  },

  methods: {
    /**
     * Call API get result list by condition search
     * Show data on table result
     *
     * @return {Object} API response for error handle
     */
    async fetch () {
      const res = await this.$dam.getBidList(this.query)
      if (Array.isArray(res.data) && res.data.length) {
        // TODO: Waiting API
        // this.total = res.meta.total
        this.bids = res.data
      }

      this.$dam.getProductList(this.query)
        .then((res) => {
          if (Array.isArray(res.data) && res.data.length) {
            // TODO: Waiting API
            // this.total = res.meta.total
            this.products = res.data
          }
        })
        .catch((err) => {
          console.error(err)

          this.$toast.error(
            this.$text.error('FAILED_TO_DATA')
          )
        })
      return res
    },

    /**
     * Show detail
     *
     * @param {Number} id - Item Id
     */
    onShowDetail (id) {
      this.setSelectedId(id)
      this.$refs.resultDetailModal.open()
    },

    /**
     * Set select id
     *
     * @param {Number} id - group id
     */
    setSelectedId (id) {
      this.selectedId = id
    }
  }
}
</script>
